<template>
	<ProviderProductsNormalized v-slot="{ productsNormalized }" :items="items">
		<BlockProductsV2View
			ref="view"
			v-bind="{ ...$props, productsNormalized, priceMoney, currencySymbol }"
			@affirm-updated="affirmUpdated"
		/>
	</ProviderProductsNormalized>
</template>

<script>
import { mapGetters } from 'vuex';
import ProviderProductsNormalized from '@components/provider-products-normalized';
import BlockProductsV2View from '@components/block-products-v2-view';

const priceMoney = (dollars, currencySymbol) =>
	dollars ? `${currencySymbol}${dollars}` : '';

export default {
	components: {
		ProviderProductsNormalized,
		BlockProductsV2View,
	},

	inheritAttrs: false,

	props: {
		items: {
			type: Array,
			default: () => [],
		},

		id: {
			type: String,
			default: null,
		},

		critical: {
			type: Boolean,
			default: false,
		},

		reversedOrderOnDesktop: {
			type: Boolean,
			default: false,
		},
	},

	computed: {
		...mapGetters(['currencySymbol']),
	},

	methods: {
		priceMoney,

		affirmUpdated({ el, index }) {
			const bottom = el.querySelector('.affirm-pmt-bottom');
			if (bottom) {
				bottom.appendChild(document.createTextNode('. '));
				const trigger = el.querySelector('.affirm-modal-trigger');
				if (trigger) {
					bottom.appendChild(trigger);
				}

				const logo = bottom.querySelector('.__affirm-logo');
				if (logo) {
					logo.setAttribute('aria-hidden', 'true');
					logo.insertAdjacentHTML('afterend', '<span class="screen-reader-only">Affirm</span>');
				}

				const { view } = this.$refs;
				if (!view) return;

				const affirmContainer = view.$refs[`affirmContainer${index}`] && view.$refs[`affirmContainer${index}`][0];
				if (!affirmContainer) return;

				while (affirmContainer.firstChild) {
					affirmContainer.removeChild(affirmContainer.firstChild);
				}

				affirmContainer.appendChild(bottom);
			}
		},
	},
};
</script>
